#ifndef GAMETIMEH
#define GAMETIMEH

/* An implementation of GameTimeFormatter from OpenComputers, flavored a bit
   like the C standard library. */

#include <inttypes.h>
#include <stdlib.h>

typedef int64_t gametime_t;
struct gametm {
  int32_t year, month, day, weekDay, yearDay, hour, minute, second;
};

gametime_t gametime(gametime_t* timep);
struct gametm* gametime2tm(const gametime_t* timep, struct gametm* tm);
size_t gamestrftime(char* s, size_t max, const char* format,
                    const struct gametm* tm);
gametime_t mkgametime(const struct gametm* tm);

#endif
