#ifndef FAKE_STRINGH
#define FAKE_STRINGH

#include <correctly_compiled.h>

/* Just enough of string.h to make Lua compile. */
#include <stddef.h>
const char* strchr(const char* s, int c);
const char* strrchr(const char* s, int c);
int strcmp(const char* s1, const char* s2);
const char* strpbrk(const char* s, const char* accept);
size_t strlen(const char* s);
void* memcpy(void* dest, const void* src, size_t n);
int memcmp(const void* a, const void* b, size_t len);
void* memchr(const void* s, int c, size_t n);
const char* strstr(const char* haystack, const char* needle);
char* strcpy(char* dst, const char* src);
size_t strspn(const char* s, const char* accept);
/* yuck! */
#define strcoll strcmp
/* not actually const */
const char* strerror(int errno);

#endif
