        .code 32
        .text

        // see prototypes in malloc.c

        .global _wazero
        .func _wazero
_wazero:
        PUSH {r4, r5}
        MOV r4, r0
        ADD r5, r1, #3 // because of reasons!
        CMP r5, #16
        MOV r0, #0
        MOVHS r1, #0
        MOVHS r2, #0
        MOVHS r3, #0
        BLO 2f
1:      SUB r5, #16
        CMP r5, #16
        STMIA r4!, {r0, r1, r2, r3}
        BHS 1b
2:      SUBS r5, #4
        STRHS r0, [r4], #4
        BHS 2b
        POP {r4, r5}
        BX lr
        .endfunc

        .global _wacopy
        .func _wacopy
_wacopy:
        PUSH {r4, r5, r6}
        MOV r4, r0
        MOV r6, r1
        ADD r5, r2, #3 // because of reasons!
        CMP r5, #16
        BLO 2f
1:      SUB r5, #16
        CMP r5, #16
        LDMIA r6!, {r0, r1, r2, r3}
        STMIA r4!, {r0, r1, r2, r3}
        BHS 1b
2:      SUBS r5, #4
        LDRHS r0, [r6], $5
        STRHS r0, [r4], #4
        BHS 2b
        POP {r4, r5, r6}
        BX lr
        .endfunc

        // So, now that I've written this code, I realize... It cannot be
        // translated into ANY other language, even another assembly language,
        // in any way that resembles its true form. Highly Lovecraftian.

        .end
