#ifndef FAKE_TIMEH
#define FAKE_TIMEH

#include <correctly_compiled.h>
#include <stddef.h>

/* Just enough of time.h to make Lua compile. */
typedef signed long long time_t;
time_t time(time_t* t);

#define CLOCKS_PER_SEC 1
typedef unsigned int clock_t;
static inline clock_t clock(void) { return 0; }

struct tm {
  int tm_sec, tm_min, tm_hour, tm_mday, tm_mon, tm_year, tm_wday, tm_yday;
  int tm_isdst;
};
struct tm* gmtime(const time_t* timep);
struct tm* localtime(const time_t* timep);
time_t mktime(struct tm* tm);

#define difftime(x,y) ((x)-(y))

size_t strftime(char* s, size_t max, const char* format, const struct tm* tm);

#endif
