#ifndef UUID_H
#define UUID_H

#include "inttypes.h"
#include <stdbool.h>

struct uuid {
  uint32_t first;
  uint16_t second, third, fourth;
  uint8_t rest[6];
};

/* writes the UUID as a string to a static buffer */
const char* uuid2staticstring(const struct uuid*);
void uuid2string(const struct uuid*, char buffer[37]);
/* returns true if valid */
bool string2uuid(struct uuid*, const char*);

#endif
