#include <stdio.h>
#include <errno.h>

int stdio_stub_zero(void) { errno = ENOSTDIO; return 0; }
int stdio_stub_eof(void) { errno = ENOSTDIO; return -1; }
void stdio_stub_void(void) { }

int fprintf(FILE* f, const char* format, ...) __attribute__((alias("stdio_stub_eof")));
FILE* fopen(const char* path, const char* mode) __attribute__((alias("stdio_stub_zero")));
FILE* freopen(const char* path, const char* mode, FILE* f) __attribute__((alias("stdio_stub_zero")));
FILE* tmpfile(void) __attribute__((alias("stdio_stub_zero")));
int fclose(FILE* f) __attribute__((alias("stdio_stub_eof")));
int feof(FILE* f) __attribute__((alias("stdio_stub_eof")));
int ferror(FILE* f) __attribute__((alias("stdio_stub_eof")));
int fflush(FILE* f) __attribute__((alias("stdio_stub_eof")));
size_t fread(void* buf, size_t size, size_t nmemb, FILE* f) __attribute__((alias("stdio_stub_zero")));
size_t fwrite(const void* buf, size_t size, size_t nmemb, FILE* f) __attribute__((alias("stdio_stub_zero")));
int getc(FILE* f) __attribute__((alias("stdio_stub_eof")));
char* fgets(char* s, int size, FILE* f) __attribute__((alias("stdio_stub_zero")));
int fputs(const char* s, FILE* f) __attribute__((alias("stdio_stub_eof")));
int ungetc(int c, FILE* f) __attribute__((alias("stdio_stub_eof")));
void clearerr(FILE* f) __attribute__((alias("stdio_stub_void")));
int fseek(FILE* f, long offset, int whence) __attribute__((alias("stdio_stub_eof")));
long ftell(FILE* f) __attribute__((alias("stdio_stub_eof")));
int setvbuf(FILE* f, char* buf, int mode, size_t size) __attribute__((alias("stdio_stub_eof")));
int remove(const char* pathname) __attribute__((alias("stdio_stub_eof")));
int rename(const char* oldpath, const char* newpath) __attribute__((alias("stdio_stub_eof")));
char* tmpnam(char* s) __attribute__((alias("stdio_stub_zero")));
